Index: sandbox/MultiChannelUSB/UserInterface.tcl
===================================================================
--- sandbox/MultiChannelUSB/UserInterface.tcl	(revision 106)
+++ sandbox/MultiChannelUSB/UserInterface.tcl	(revision 143)
@@ -923,112 +1246,575 @@
 # -------------------------------------------------------------------------
 
-    EptDisplay instproc reset {} {
-        my instvar data xvec yvec
-        my instvar number_val directory
-
-        set data {}
-
-        set directory $::env(HOMEPATH)
-        set number_val 10
-
-        for {set i 0} {$i < 11} {incr i} {
-          $yvec($i) set {}
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc start {} {
+    CntDisplay instproc start {} {
         my instvar config
 
-        trace add variable [myvar recs_val] write [myproc recs_val_update]
         trace add variable [myvar data] write [myproc data_update]
-        trace add variable [myvar last] write [myproc data_update]
-
-    }
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc setup {} {
+
+        trace add variable [myvar thrs_val] write [myproc thrs_val_update]
+
+        trace add variable [myvar cntr] write [myproc cntr_update]
+        trace add variable [myvar recs] write [myproc recs_update]
+
+        trace add variable [myvar axis] write [myproc axis_update]
+
+        ${config}.axis_check select
+
+        my set thrs_val 100
+
+        my set cntr_val 100
+        my set cntr_bak 100
+        my set recs_val 100
+        my set recs_bak 100
+
+#        my cntr_reset
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc setup {} {
         my instvar master
-        my instvar data xvec yvec graph
-        my instvar config number_val
+        my instvar xvec yvec graph
+        my instvar config
+        my instvar cntr_ms
 
         # create a graph widget and show a grid
-        set display [frame ${master}.display]
-
-        set graph(0) [graph ${display}.graph0 -height 200 -leftmargin 80]
-        $graph(0) crosshairs configure -hide no -linewidth 2 -dashes { 1 1 }
-        $graph(0) grid configure -hide no
-        $graph(0) legend configure -hide yes
-        $graph(0) axis configure x -min 0 -max 10000
-        $graph(0) axis configure y -min 0 -max 4100
-
-        set graph(1) [graph ${display}.graph1 -height 200 -leftmargin 80]
-        $graph(1) crosshairs configure -hide no -linewidth 2 -dashes { 1 1 }
-        $graph(1) grid configure -hide no
-        $graph(1) legend configure -hide yes
-        $graph(1) axis configure x -min 0 -max 10000 -hide yes
-        $graph(1) axis configure y -min 0 -max 4100
-
-        set graph(2) [graph ${display}.graph2 -height 200 -leftmargin 80]
-        $graph(2) crosshairs configure -hide no -linewidth 2 -dashes { 1 1 }
-        $graph(2) grid configure -hide no
-        $graph(2) legend configure -hide yes
-        $graph(2) axis configure x -min 0 -max 10000 -hide yes
-        $graph(2) axis configure y -min 0 -max 4100
-
-        set graph(3) [graph ${display}.graph3 -height 100 -leftmargin 80]
-        $graph(3) crosshairs configure -hide no -linewidth 2 -dashes { 1 1 }
-        $graph(3) grid configure -hide no
-        $graph(3) legend configure -hide yes
-        $graph(3) axis configure x -min 0 -max 10000 -hide yes
-        $graph(3) axis configure y -min 0 -max 25
-
-        scale ${master}.last -orient horizontal -from 1 -to 35 -tickinterval 0 -showvalue no -variable [myvar last]
-
-        set config [frame ${master}.config -width 120]
-
-        label ${config}.recs -text {number of records}
-        spinbox ${config}.recs_field -from 5 -to 100 \
-            -increment 5 -width 10 -textvariable [myvar recs_val] \
-            -validate all -vcmd {::mca::validate 100 %P}
-
-        frame ${config}.spc1 -width 10 -height 10
-
-        button ${config}.sequence -text {Start Recording}  \
-            -bg red -activebackground red -command [myproc sequence]
-
-        frame ${config}.spc2 -width 10 -height 10
-
-        label ${config}.stat -text {}
-
-        frame ${config}.spc3 -width 10 -height 20
-
-        button ${config}.acquire -text Acquire \
-            -bg green -activebackground green -command [myproc acquire]
+        set graph [graph ${master}.graph -height 250 -leftmargin 80]
+        $graph crosshairs configure -hide no -linewidth 1 -color darkblue -dashes {2 2}
+        $graph grid configure -hide no
+        $graph legend configure -hide yes
+        $graph axis configure x -min 0 -max 16384
+
+        set config [frame ${master}.config -width 170]
+
+        checkbutton ${config}.axis_check -text {log scale} -variable [myvar axis]
+
+        frame ${config}.spc1 -width 170 -height 30
+
+        frame ${config}.chan_frame -borderwidth 0 -width 170
+        legendLabel ${config}.chan_frame 0 mean  {Mean value}
+        legendLabel ${config}.chan_frame 1 entr  {Total entries}
+        legendLabel ${config}.chan_frame 2 empty {}
+        legendLabel ${config}.chan_frame 3 axisy {Bin entries}
+        legendLabel ${config}.chan_frame 4 axisx {Bin number}
+
+        frame ${config}.spc3 -width 170 -height 30
+
+        label ${config}.thrs -text {amplitude threshold}
+        spinbox ${config}.thrs_field -from 1 -to 4095 \
+            -increment 5 -width 10 -textvariable [myvar thrs_val] \
+            -validate all -vcmd {::mca::validate 4095 4 %P}
+
+        frame ${config}.spc4 -width 170 -height 30
+
+        label ${config}.cntr -text {time of exposure (s)}
+        spinbox ${config}.cntr_field -from 0 -to 9999 \
+            -increment 10 -width 10 -textvariable [myvar cntr_val] \
+            -validate all -vcmd {::mca::validate 9999 4 %P}
+
+        frame ${config}.spc5 -width 170 -height 10
+
+        label ${config}.recs -text {number of exposures}
+        spinbox ${config}.recs_field -from 0 -to 99999 \
+            -increment 10 -width 10 -textvariable [myvar recs_val] \
+            -validate all -vcmd {::mca::validate 99999 5 %P}
+
+        frame ${config}.spc6 -width 170 -height 10
+
+        button ${config}.start -text {Start}  \
+            -bg yellow -activebackground yellow -command [myproc recs_start]
+
+        button ${config}.reset -text Reset \
+            -bg red -activebackground red -command [myproc cntr_reset]
+
+        frame ${config}.spc7 -width 170 -height 30
+
         button ${config}.register -text Register \
             -bg lightblue -activebackground lightblue -command [myproc register]
 
-
+        grid ${config}.axis_check -sticky w
+        grid ${config}.spc1
+        grid ${config}.chan_frame -sticky ew -padx 5
+        grid ${config}.spc3
+        grid ${config}.thrs -sticky w -pady 1 -padx 3
+        grid ${config}.thrs_field -sticky ew -pady 1 -padx 5
+        grid ${config}.spc4
+        grid ${config}.cntr -sticky w -pady 1 -padx 3
+        grid ${config}.cntr_field -sticky ew -pady 1 -padx 5
+        grid ${config}.spc5
         grid ${config}.recs -sticky w -pady 1 -padx 3
         grid ${config}.recs_field -sticky ew -pady 1 -padx 5
+        grid ${config}.spc6
+        grid ${config}.start -sticky ew -pady 3 -padx 5
+        grid ${config}.reset -sticky ew -pady 3 -padx 5
+        grid ${config}.spc7
+        grid ${config}.register -sticky ew -pady 3 -padx 5
+
+        grid ${graph} -row 0 -column 0 -sticky news
+        grid ${config} -row 0 -column 1
+
+        grid rowconfigure ${master} 0 -weight 1
+        grid columnconfigure ${master} 0 -weight 1
+        grid columnconfigure ${master} 1 -weight 0 -minsize 80
+
+        grid columnconfigure ${config}.chan_frame 1 -weight 1
+
+        # enable zooming
+        Blt_ZoomStack $graph
+
+        my crosshairs $graph
+
+        #bind .graph <Motion> {%W crosshairs configure -position @%x,%y}
+
+        # create one element with data for the x and y axis, no dots
+        $graph element create Spectrum1 -color blue -linewidth 2 -symbol none -smooth step -xdata [myvar xvec] -ydata [myvar yvec]
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc coor_update {W x y} {
+        my instvar config graph
+
+        $W crosshairs configure -position @${x},${y}
+
+        set index [$W axis invtransform x $x]
+        set index [::tcl::mathfunc::round $index]
+        catch {
+            ${config}.chan_frame.axisy_value configure -text [[myvar yvec] index $index]
+            ${config}.chan_frame.axisx_value configure -text ${index}.0
+        }
+    }
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc crosshairs {graph} {
+        set method [myproc coor_update]
+        bind $graph <Motion> [list [self] coor_update %W %x %y]
+        bind $graph <Leave> {
+            %W crosshairs off
+        }
+        bind $graph <Enter> {
+            %W crosshairs on
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc thrs_val_update args {
+        my instvar controller config thrs_val
+
+        if {[string equal $thrs_val {}]} {
+            set thrs_val 0
+        }
+
+        set val_addr [format %02x 12]
+
+        ${config}.thrs_field configure -state normal
+        set value [format %03x $thrs_val]
+
+        $controller usbCmd 000200${val_addr}00040${value}
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc cntr_update args {
+        my instvar cntr cntr_val
+        set cntr_val [expr {${cntr}/20000000}]
+
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc recs_update args {
+        my instvar recs recs_val
+        set recs_val [expr {${recs}*1}]
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc cntr_setup {} {
+        my instvar controller cntr_val
+
+        set cntr_tmp [expr {${cntr_val} * 20000000}]
+        set word0 [format {%08x} [expr {${cntr_tmp} & 0xFFFFFFFF}]]
+        set word1 [format {%08x} [expr {${cntr_tmp} >> 32}]]
+
+        set prefix [format {%x} 9]
+
+        set command {}
+        append command 0001${prefix}000000200000004[string range $word0 4 7]
+        append command 0001${prefix}000000200010004[string range $word0 0 3]
+        append command 0001${prefix}000000200020004[string range $word1 4 7]
+        append command 0001${prefix}000000200030004[string range $word1 0 3]
+
+        # send counter value
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc recs_setup {} {
+        my instvar controller recs_val
+
+        set word0 [format {%08x} [expr {${recs_val} & 0xFFFFFFFF}]]
+        set word1 [format {%08x} [expr {${recs_val} >> 32}]]
+
+        set prefix [format {%x} 10]
+
+        set command {}
+        append command 0001${prefix}000000200000004[string range $word0 4 7]
+        append command 0001${prefix}000000200010004[string range $word0 0 3]
+        append command 0001${prefix}000000200020004[string range $word1 4 7]
+        append command 0001${prefix}000000200030004[string range $word1 0 3]
+
+        # send counter value
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc cntr_reset {} {
+        my instvar controller after_handle
+        my instvar cntr_val cntr_bak recs_val recs_bak
+
+        my cntr_stop
+
+        set value [format {%04x} [expr {1 << 11}]]
+        $controller usbCmd 000200000004${value}0002000000040000
+
+        my recs_stop
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc cntr_ready {} {
+        my instvar config cntr_val cntr_bak recs_val recs_bak
+
+        set cntr_val $cntr_bak
+        set recs_val $recs_bak
+
+        ${config}.start configure -text Start -command [myproc recs_start]
+        ${config}.reset configure -state active
+
+        ${config}.start configure -state active
+        ${config}.cntr_field configure -state normal
+        ${config}.recs_field configure -state normal
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc recs_start {} {
+        my instvar controller config auto
+        my instvar cntr_val cntr_bak recs_val recs_bak
+
+        if {$cntr_val > 0 && $recs_val > 0} {
+            ${config}.start configure -text {Stop} -command [myproc recs_stop]
+            ${config}.cntr_field configure -state disabled
+            ${config}.recs_field configure -state disabled
+
+            set cntr_bak $cntr_val
+            set recs_bak $recs_val
+
+            my cntr_setup
+            my recs_setup
+
+            set val_addr [format {%02x} 16]
+
+            $controller usbCmd 000200${val_addr}00040002
+
+            set auto 1
+
+            after 100 [myproc acquire_loop]
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc recs_stop {} {
+        my instvar cntr_val cntr_bak recs_val recs_bak
+
+        my cntr_stop
+
+        set cntr_val $cntr_bak
+        my cntr_setup
+
+        set recs_val $recs_bak
+        my recs_setup
+
+        my acquire
+
+        my cntr_ready
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc cntr_stop {} {
+        my instvar controller config auto
+
+        set val_addr [format {%02x} 16]
+
+        $controller usbCmd 000200${val_addr}00040000
+
+        set auto 0
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc acquire_loop {} {
+        my instvar recs_val auto
+
+        my acquire
+
+        if {$recs_val == 0} {
+            my cntr_stop
+            my cntr_ready
+        } elseif {$auto} {
+            after 1000 [myproc acquire_loop]
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc data_update args {
+        my instvar config data
+        usb::convertBlt $data 2 [myvar yvec]
+
+        ${config}.chan_frame.mean_value configure \
+            -text [format {%.2e} [usb::integrateBlt [myvar yvec] 1]]
+        ${config}.chan_frame.entr_value configure \
+            -text [usb::integrateBlt [myvar yvec] 0]
+
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc axis_update args {
+        my instvar axis graph
+        if {$axis} {
+            $graph axis configure y -min 1 -max 1E5 -logscale yes
+        } else {
+            $graph axis configure y -min {} -max {} -logscale no
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc acquire {} {
+        my instvar controller config
+        my instvar cntr cntr_val recs recs_val
+
+        set size 16384
+
+        set prefix [format {%x} 8]
+
+        set value [format {%08x} $size]
+
+        set command 0001${prefix}000000200000001[string range $value 0 3]0003[string range $value 4 7]00050000
+
+        $controller usbCmdReadRaw $command [expr {$size * 2}] [myvar data]
+
+        set prefix [format {%x} 9]
+        set command 0001${prefix}000000200000003000400050000
+
+        $controller usbCmdReadHex $command 8 1 [myvar cntr]
+
+        set prefix [format {%x} 10]
+        set command 0001${prefix}000000200000003000400050000
+
+        $controller usbCmdReadHex $command 8 1 [myvar recs]
+   }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc save_data {data} {
+
+        set types {
+            {{Data Files}       {.dat}        }
+            {{All Files}        *             }
+        }
+
+        set stamp [clock format [clock seconds] -format %Y%m%d_%H%M%S]
+        set fname counts_${stamp}.dat
+
+        set fname [tk_getSaveFile -filetypes $types -initialfile $fname]
+        if {[string equal $fname {}]} {
+            return
+        }
+
+        set x [catch {
+            set fid [open $fname w+]
+            puts $fid $data
+            close $fid
+        }]
+
+        if { $x || ![file exists $fname] || ![file isfile $fname] || ![file readable $fname] } {
+            tk_messageBox -icon error \
+                -message "An error occurred while writing to \"$fname\""
+        } else {
+            tk_messageBox -icon info \
+                -message "File \"$fname\" written successfully"
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    CntDisplay instproc register {} {
+        my save_data [join [[myvar yvec] range 0 16383] \n]
+    }
+
+# -------------------------------------------------------------------------
+
+    Class OscDisplay -parameter {
+        {master}
+        {controller}
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc init {} {
+        my instvar sequence data xvec yvec
+
+        set data {}
+        
+        set sequence 0
+
+#        set xvec [vector create #auto(262144)]
+        set xvec [vector create #auto(10000)]
+
+        for {set i 1} {$i <= 9} {incr i} {
+#          dict set yvec $i [vector create #auto(262144)]
+          dict set yvec $i [vector create #auto(10000)]
+        }
+
+        # fill one vector for the x axis
+#        $xvec seq 0 262143
+        $xvec seq 0 10000
+
+        my setup
+
+        next
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc destroy {} {
+        next
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc start {} {
+        my instvar config
+        my instvar recs_val directory
+
+        set directory $::env(HOMEPATH)
+        set recs_val 100
+
+        trace add variable [myvar chan] write [myproc chan_update]
+
+        trace add variable [myvar data] write [myproc data_update]
+
+        trace add variable [myvar auto] write [myproc auto_update]
+
+        trace add variable [myvar thrs] write [myproc thrs_update 0]
+        trace add variable [myvar thrs_val] write [myproc thrs_update 0]
+
+        trace add variable [myvar recs_val] write [myproc recs_val_update]
+
+        trace add variable [myvar last] write [myproc last_update]
+
+        ${config}.chan_frame.chan1_check select
+        ${config}.chan_frame.chan2_check select
+        ${config}.chan_frame.chan3_check select
+        ${config}.chan_frame.chan4_check select
+        ${config}.chan_frame.chan5_check select
+        ${config}.chan_frame.chan6_check select
+
+        ${config}.thrs_check select
+        ${config}.thrs_field set 100
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc setup {} {
+        my instvar master
+        my instvar xvec yvec graph
+        my instvar config
+
+        # create a graph widget and show a grid
+        set graph [graph ${master}.graph -height 250 -leftmargin 80]
+        $graph crosshairs configure -hide no -linewidth 1 -color darkblue -dashes {2 2}
+        $graph grid configure -hide no
+        $graph legend configure -hide yes
+        $graph axis configure x -min 0 -max 10000
+        $graph axis configure y -min 0 -max 4100
+
+#        scale ${master}.last -orient horizontal -from 1 -to 27 -tickinterval 0 -showvalue no -variable [myvar last]
+
+        set config [frame ${master}.config -width 170]
+
+        frame ${config}.chan_frame -width 170
+        legendButton ${config}.chan_frame 0 chan1 {Channel 1} [myvar chan(1)] turquoise2
+        legendButton ${config}.chan_frame 1 chan2 {Channel 2} [myvar chan(2)] SpringGreen2
+        legendButton ${config}.chan_frame 2 chan3 {Channel 3} [myvar chan(3)] orchid2
+        legendButton ${config}.chan_frame 3 chan4 {Channel 4} [myvar chan(4)] orange2
+        legendButton ${config}.chan_frame 4 chan5 {Channel 5} [myvar chan(5)] blue1 white
+        legendButton ${config}.chan_frame 5 chan6 {Channel 6} [myvar chan(6)] gray65 white
+        legendLabel  ${config}.chan_frame 6 axisx {Time axis}
+
+        frame ${config}.spc1 -width 170 -height 30
+
+        checkbutton ${config}.auto_check -text {auto update} -variable [myvar auto]
+
+        frame ${config}.spc2 -width 170 -height 30
+
+        checkbutton ${config}.thrs_check -text threshold -variable [myvar thrs]
+        spinbox ${config}.thrs_field -from 1 -to 4095 \
+            -increment 5 -width 10 -textvariable [myvar thrs_val] \
+            -validate all -vcmd {::mca::validate 4095 4 %P}
+
+        frame ${config}.spc3 -width 170 -height 30
+
+        button ${config}.acquire -text Acquire \
+            -bg green -activebackground green -command [myproc acquire_start]
+        button ${config}.register -text Register \
+            -bg lightblue -activebackground lightblue -command [myproc register]
+
+        frame ${config}.spc4 -width 170 -height 30
+
+        label ${config}.recs -text {number of records}
+        spinbox ${config}.recs_field -from 0 -to 10000 \
+            -increment 10 -width 10 -textvariable [myvar recs_val] \
+            -validate all -vcmd {::mca::validate 10000 5 %P}
+
+        frame ${config}.spc5 -width 170 -height 10
+
+        button ${config}.sequence -text {Start Recording} -command [myproc sequence_start] \
+            -bg yellow -activebackground yellow
+
+        frame ${config}.spc6 -width 170 -height 10
+
+        button ${config}.recover -text {Read file} \
+            -bg lightblue -activebackground lightblue -command [myproc recover]
+
+        grid ${config}.chan_frame -sticky ew
         grid ${config}.spc1
-        grid ${config}.sequence -sticky ew -pady 3 -padx 5
+        grid ${config}.auto_check -sticky w
         grid ${config}.spc2
-        grid ${config}.stat -sticky w -pady 1 -padx 3
+        grid ${config}.thrs_check -sticky w
+        grid ${config}.thrs_field -sticky ew -pady 1 -padx 5
         grid ${config}.spc3
         grid ${config}.acquire -sticky ew -pady 3 -padx 5
         grid ${config}.register -sticky ew -pady 3 -padx 5
-
-        grid ${graph(3)} -row 0 -column 0 -sticky news
-        grid ${graph(2)} -row 1 -column 0 -sticky news
-        grid ${graph(1)} -row 2 -column 0 -sticky news
-        grid ${graph(0)} -row 3 -column 0 -sticky news
-
-        grid ${display} -row 0 -column 0 -sticky news
+        grid ${config}.spc4
+        grid ${config}.recs -sticky w -pady 1 -padx 3
+        grid ${config}.recs_field -sticky ew -pady 1 -padx 5
+        grid ${config}.spc5
+        grid ${config}.sequence -sticky ew -pady 3 -padx 5
+        grid ${config}.spc6
+        grid ${config}.recover -sticky ew -pady 3 -padx 5
+
+        grid ${graph} -row 0 -column 0 -sticky news
         grid ${config} -row 0 -column 1
 
-        grid ${master}.last -row 1 -column 0 -columnspan 2 -sticky ew
+#        grid ${master}.last -row 1 -column 0 -columnspan 2 -sticky ew
 
         grid rowconfigure ${master} 0 -weight 1
